diff -urN 15.05.ORG/target/linux/ramips/base-files/etc/board.d/01_leds 15.05/target/linux/ramips/base-files/etc/board.d/01_leds
--- 15.05.ORG/target/linux/ramips/base-files/etc/board.d/01_leds	2016-12-02 11:19:00.218238666 +0900
+++ 15.05/target/linux/ramips/base-files/etc/board.d/01_leds	2016-12-08 11:15:07.644581720 +0900
@@ -77,6 +77,9 @@
 		ucidef_set_led_netdev "lan" "lan" "comfast:white:ethernet" eth0.1
 		set_wifi_led "comfast:white:wifi"
 		;;
+	cs-qr10)
+		ucidef_set_led_default "power" "POWER" "cs-qr10:red:power" "1"
+		;;
 	cy-swr1100)
 		ucidef_set_led_default "wps" "WPS" "samsung:blue:wps" "0"
 		set_usb_led "samsung:blue:usb"
diff -urN 15.05.ORG/target/linux/ramips/base-files/etc/board.d/02_network 15.05/target/linux/ramips/base-files/etc/board.d/02_network
--- 15.05.ORG/target/linux/ramips/base-files/etc/board.d/02_network	2016-12-02 11:19:00.218238666 +0900
+++ 15.05/target/linux/ramips/base-files/etc/board.d/02_network	2016-12-09 22:38:53.887059928 +0900
@@ -54,6 +54,7 @@
 	all5002 | \
 	all5003 | \
 	broadway | \
+	cs-qr10 | \
 	dcs-930| \
 	dcs-930l-b1| \
 	ht-tm02| \
diff -urN 15.05.ORG/target/linux/ramips/base-files/etc/diag.sh 15.05/target/linux/ramips/base-files/etc/diag.sh
--- 15.05.ORG/target/linux/ramips/base-files/etc/diag.sh	2016-12-02 11:19:00.218238666 +0900
+++ 15.05/target/linux/ramips/base-files/etc/diag.sh	2016-12-08 11:20:27.228597967 +0900
@@ -39,6 +39,9 @@
 	cf-wr800n)
 		status_led="comfast:white:wps"
 		;;
+	cs-qr10)
+		status_led="cs-qr10:red:power"
+		;;
 	cy-swr1100)
 		status_led="samsung:blue:wps"
 		;;
diff -urN 15.05.ORG/target/linux/ramips/base-files/lib/ramips.sh 15.05/target/linux/ramips/base-files/lib/ramips.sh
--- 15.05.ORG/target/linux/ramips/base-files/lib/ramips.sh	2016-12-02 11:19:00.222238666 +0900
+++ 15.05/target/linux/ramips/base-files/lib/ramips.sh	2016-12-07 17:14:58.493286895 +0900
@@ -211,6 +211,9 @@
 	*"Linksys RE6500")
 		name="re6500"
 		;;
+	*"Planex CS-QR10")
+		name="cs-qr10"
+		;;
 	*"Planex MZK-750DHP")
 		name="mzk-750dhp"
 		;;
diff -urN 15.05.ORG/target/linux/ramips/base-files/lib/upgrade/platform.sh 15.05/target/linux/ramips/base-files/lib/upgrade/platform.sh
--- 15.05.ORG/target/linux/ramips/base-files/lib/upgrade/platform.sh	2016-12-02 11:19:00.222238666 +0900
+++ 15.05/target/linux/ramips/base-files/lib/upgrade/platform.sh	2016-12-07 17:14:15.437284706 +0900
@@ -34,6 +34,7 @@
 	broadway | \
 	carambola | \
 	cf-wr800n | \
+	cs-qr10 | \
 	d105 | \
 	dap-1350 | \
 	dcs-930 | \
diff -urN 15.05.ORG/target/linux/ramips/dts/CS-QR10.dts 15.05/target/linux/ramips/dts/CS-QR10.dts
--- 15.05.ORG/target/linux/ramips/dts/CS-QR10.dts	1970-01-01 09:00:00.000000000 +0900
+++ 15.05/target/linux/ramips/dts/CS-QR10.dts	2016-12-09 23:06:30.115144129 +0900
@@ -0,0 +1,116 @@
+/dts-v1/;
+
+/include/ "mt7620a.dtsi"
+
+/ {
+	compatible = "ralink,mt7620a-soc";
+	model = "Planex CS-QR10";
+
+	palmbus@10000000 {
+		gpio1: gpio@638 {
+			status = "okay";
+		};
+
+		i2c@900 {
+			status = "okay";
+		};
+
+		spi@b00 {
+			status = "okay";
+
+			m25p80@0 {
+				#address-cells = <1>;
+				#size-cells = <1>;
+				compatible = "en25q64";
+				reg = <0 0>;
+				linux,modalias = "m25p80", "mx25l6405d";
+				spi-max-frequency = <10000000>;
+
+				partition@0 {
+					label = "u-boot";
+					reg = <0x0 0x30000>;
+					read-only;
+				};
+
+				partition@30000 {
+					label = "u-boot-env";
+					reg = <0x30000 0x10000>;
+					read-only;
+				};
+
+				factory: partition@40000 {
+					label = "factory";
+					reg = <0x40000 0x10000>;
+					read-only;
+				};
+
+				partition@50000 {
+					label = "firmware";
+					reg = <0x50000 0x7b0000>;
+				};
+			};
+		};
+	};
+
+	pinctrl {
+		state_default: pinctrl0 {
+			gpio {
+				ralink,group = "spi refclk", "rgmii1";
+				ralink,function = "gpio";
+			};
+		};
+	};
+
+	ethernet@10100000 {
+		pinctrl-names = "default";
+		pinctrl-0 = <&ephy_pins>;
+
+		mtd-mac-address = <&factory 0x4>;
+		ralink,port-map = "llllw";
+	};
+
+	gsw@10110000 {
+		ralink,port4 = "ephy";
+	};
+
+	sdhci@10130000 {
+		status = "okay";
+	};
+
+	ehci@101c0000 {
+		status = "okay";
+	};
+
+	ohci@101c1000 {
+		status = "okay";
+	};
+
+	wmac@10180000 {
+		ralink,mtd-eeprom = <&factory 0>;
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+		power {
+			label = "cs-qr10:red:power";
+			gpios = <&gpio1 4 1>;
+		};
+	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+		s1 {
+			label = "reset";
+			gpios = <&gpio1 1 1>;
+			linux,code = <0x198>;
+		};
+		s2 {
+			label = "wps";
+			gpios = <&gpio1 3 1>;
+			linux,code = <0x211>;
+		};
+	};
+};
diff -urN 15.05.ORG/target/linux/ramips/image/Makefile 15.05/target/linux/ramips/image/Makefile
--- 15.05.ORG/target/linux/ramips/image/Makefile	2016-12-02 11:19:00.234238667 +0900
+++ 15.05/target/linux/ramips/image/Makefile	2016-12-08 11:24:39.416610788 +0900
@@ -900,6 +900,7 @@
 na930_mtd_size=20971520
 Image/Build/Profile/NA930=$(call BuildFirmware/CustomFlash/$(1),$(1),na930,NA930,$(na930_mtd_size))
 Image/Build/Profile/MZK-750DHP=$(call BuildFirmware/Default8M/$(1),$(1),mzk-750dhp,MZK-750DHP)
+Image/Build/Profile/CS-QR10=$(call BuildFirmware/Default8M/$(1),$(1),cs-qr10,CS-QR10)
 Image/Build/Profile/Y1=$(call BuildFirmware/Default16M/$(1),$(1),Lenovo-y1,Y1)
 Image/Build/Profile/Y1S=$(call BuildFirmware/Default16M/$(1),$(1),Lenovo-y1s,Y1S)
 Image/Build/Profile/MLW221=$(call BuildFirmware/Default16M/$(1),$(1),mlw221,MLW221)
@@ -933,6 +934,7 @@
 	$(call Image/Build/Profile/WHR600D,$(1))
 	$(call Image/Build/Profile/WHR1166D,$(1))
 	$(call Image/Build/Profile/MZK-750DHP,$(1))
+	$(call Image/Build/Profile/CS-QR10,$(1))
 	$(call Image/Build/Profile/NA930,$(1))
 	$(call Image/Build/Profile/Y1,$(1))
 	$(call Image/Build/Profile/Y1S,$(1))
diff -urN 15.05.ORG/target/linux/ramips/mt7620/profiles/planex.mk 15.05/target/linux/ramips/mt7620/profiles/planex.mk
--- 15.05.ORG/target/linux/ramips/mt7620/profiles/planex.mk	1970-01-01 09:00:00.000000000 +0900
+++ 15.05/target/linux/ramips/mt7620/profiles/planex.mk	2016-12-08 14:13:25.229125573 +0900
@@ -0,0 +1,19 @@
+#
+# Copyright (C) 2014 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+define Profile/CS-QR10
+	NAME:=Planex CS-QR10
+	PACKAGES:= kmod-usb-core kmod-usb2 kmod-usb-ohci \
+		i2c-core kmod-i2c-ralink kmod-sound-core kmod-sound-mtk \
+		kmod-sdhci-mt7620 kmod-nls-cp437 kmod-nls-iso8859-1 kmod-fs-vfat \
+		kmod-video-core kmod-video-uvc
+endef
+
+define Profile/CS-QR10/Description
+	Package set optimized for the Planex CS-QR10.
+endef
+$(eval $(call Profile,CS-QR10))
